//
// Copyright (C) 1998, Mark W J Redding <mark@grawlfang.demon.co.uk>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

/***********************************************
** Source Dump From QtEZ http://qtez.zax.net/qtez
** ---------------------------------------------
** Dumped: Wed Nov 18 19:34:59 1998
**     To: .//Kpppsvr.h
**     By: mark
***********************************************/

#ifndef QTEZ_OUTP
 #define QTEZ_OUTP "QTEZ v0.77a"
#endif

#ifndef KPPPSVR_H
#define KPPPSVR_H

/* Project Specific Includes */
#include "./main.h"

/* Library Includes */
#include <qdialog.h>
#include <qwidget.h>
#include <qpushbt.h>
#include <qtimer.h>
#include <ktopwidget.h>
#include <kstatusbar.h>

/* Class Includes */
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "pppsvr.h"


class
Kpppsvr : public KTopLevelWidget
{
	 Q_OBJECT
private:
	int m_socket;
	int m_hostPort;
	struct sockaddr_in m_server;
	char m_hostAddr[128];
	int m_interval;

	KConfig* config;
	KStatusBar* statusBar;
	QTimer* timer;

	QPushButton *m_buttonM;
	QPushButton *m_buttonG;
	QPushButton *m_buttonF;
	QPushButton *m_buttonL;
	QPushButton *m_buttonO;
	QPushButton *m_buttonT;
	QPushButton *m_buttonZ;
	QPushButton *m_buttonK;
	QPushButton *m_buttonR;
	QPushButton *m_buttonU;
	QPushButton *m_buttonD;
	QPushButton *m_buttonX;

	void SendPPP(char , int slt=0);
	void SocketSetup();
public:
	Kpppsvr(QWidget *parent=0, char *name=0);
	~Kpppsvr();
	setTimer();
//	 friend int main(int, char **);
protected:
signals:
	void done();
public slots:
	StartPPP();
	StopPPP();
	RestartPPP();
	KeepAliveOn();
	KeepAliveOff();
	KillPPP();
	ProxyOnline();
	ProxyOffline();
	ProxyFetch();
	ProxyPurge();
	SendMail();
	ExitApp();
	timerDone();
};
#endif
